$(function(){

window.acmsColorPicker  = function ( elm )
{
    var settings = {
        palette: [
            'ffffff', 'ffccc9', 'ffce93', 'fffc9e', 'ffffc7', '9aff99', '96fffb', 'cdffff', 'cbcefb',
            'cfcfcf', 'fd6864', 'fe996b', 'fffe65', 'fcff2f', '67fd9a', '38fff8', '68fdff', '9698ed',
            'c0c0c0', 'fe0000', 'f8a102', 'ffcc67', 'f8ff00', '34ff34', '68cbd0', '34cdf9', '6665cd',
            '9b9b9b', 'cb0000', 'f56b00', 'ffcb2f', 'ffc702', '32cb00', '00d2cb', '3166ff', '6434fc',
            '656565', '9a0000', 'ce6301', 'cd9934', '999903', '009901', '329a9d', '3531ff', '6200c9',
            '343434', '680100', '963400', '986536', '646809', '036400', '34696d', '00009b', '303498',
            '000000', '330001', '643403', '663234', '343300', '013300', '003532', '010066', '340096'
        ]
    },
    $target     = null,
    $bgcolor    = null,
    $submit     = $('.js-acms-color-picker-submit', elm);

    var i = 0, iz = settings.palette.length, color,
    select = '<div style="background-color:#FFF;">',
    $pallete;

    for (; i<iz; i++) {
        color = settings.palette[i];
        select += '<a style="display:block; float:left; width:30px; height:30px; margin:5px; border:solid 1px #444; cursor:pointer; background-color: #'+color+'">&nbsp;</a>';
    }
    select += '</div>';

    $pallete = $($.parseHTML(select));
    $('a', $pallete).bind('click', function(e) {
    	e.preventDefault();
        var $self   = $(this);
        var hex_rgb = $self.css('background-color'),
            r, g, b, hex_color;

        if (hex_rgb.match(/^rgb\((\d+),\s?(\d+),\s?(\d+)\)$/)) {
            r = parseInt(RegExp.$1);
            g = parseInt(RegExp.$2);
            b = parseInt(RegExp.$3);
            if ( r !== void 0 ) {
                r = ('00' + r.toString(16)).slice(-2).toUpperCase();
                g = ('00' + g.toString(16)).slice(-2).toUpperCase();
                b = ('00' + b.toString(16)).slice(-2).toUpperCase();
                hex_color = '#'+r+g+b;
            }
        }
        if ( r === void 0 ) {
            hex_color = hex_rgb.toUpperCase();
        }
        $bgcolor.css('background-color', hex_rgb);
        $target.val(hex_color);

        $pallete.dialog('close');
    });

    $submit.bind('click', function(e) {
    	e.preventDefault();
        var $self   = $(this);
        $target     = $($self.data('target'));
        $bgcolor    = $($self.data('bgcolor'));

        $pallete.dialog({
            title   : '色を選択',
            close   : function ( )
            {
                $pallete.hide();
            }
        });
        $win_w = $(window).width();
        $pallete.dialog("option", {width:(($win_w > 320)?430:280)});
        $pallete.dialog('open');
        $pallete.dialog('widget').position({
            'of'    : $submit,
            'my'    : 'left bottom',
            'at'    : 'right top',
            'collision' : 'none'
        });

        return false;
    });
};

	/*アイコン選択のトグル*/
	$(document).on("click",".js-icon-choice",function(e){
		e.preventDefault();
		var href = $(this).attr("href");
		$(href).toggle();
	});
	/*プレビュー、および選択*/
	$(document).on("click",".js-select-icon a",function(e){
		e.preventDefault();
		var preview = $(this).parents(".js-select-icon").data("preview");
		var target = $(this).parents(".js-select-icon").data("target");
		var classes = $(this).attr("class");
		$(preview).attr("class",classes);
		$(target).val(classes);
	});

	// $(".js-acms-color-picker").each(function(){
	// 	acmsColorPicker(this);
	// });
});
